/////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                 //
//                                     Deform Terrain                                              //
//                                                                           by MARKUS WIEDENMEYER //
/////////////////////////////////////////////////////////////////////////////////////////////////////

// BE SURE THAT YOUR CAMERA- AND MOUSEMOVEMENT IS STOPPED IF YOU CALL DEFORM TERRAIN !!!!

//****************************** This defines you can change **************************************//

#define dt_mouse_speed          100                                                                // speed of mouse movement
#define dt_scale_marker         0.8                                                                // the size of the vertex markers
#define dt_count_max_terrains   100                                                                // if you have more than 100 terrains, change it here
#define dt_more_particle        100000                                                             // 100000 more particles, for every one vertexmarker, increase if some vertexmarkers flickering
#define dt_count_marker         1000000                                                            // for a terrain with max 1000 * 1000 vertices

#define dt_terrain_skill        skill99                                                            // change it if you want another skill for testing if it is a terrain
#define dt_skill_value          100                                                                // the terrains should have this value at the testing skill
                                                                                                   // all entities with this skill under this value will be removed, all over this value will be let in the level
//*************************************************************************************************//

#ifndef windows_h
	#include <windows.h>
#endif

PANEL* DT_PANEL_PAN;                                                                               // prototypes
PANEL* DT_HELP_PAN;
void DT_SAVE_STEP(Scancode);

var dt_vertex_nr     = 0;                                                                          // for store the vertex number in skill1
var dt_vertices      = 0;                                                                          // contains the counter of vertices
var dt_terr_x        = 0;                                                                          // vertices of the terrain in X - direction
var dt_terr_y        = 0;                                                                          // vertices of the terrain in Y - direction
var dt_count_steps   = 0;                                                                          // contains the steps for the UNDO function
var dt_pan_active    = 0;                                                                          // is set to 1 if the panel will be moved or clicked a button
var dt_fhandle       = 0;                                                                          // filehandle for data save / write
var dt_count_terrain = 0;                                                                          // how much terrains are in the level

var dt_scan_radius  = 0;                                                                           // radius of the moved entities                                              **(can set in the Panel)**
var dt_mode         = 0;                                                                           // mode of vertexmoving                                                      **(can set in the Panel)**
var dt_vertex_speed = 0;                                                                           // speed of vertexmoving                                                     **(can set in the Panel)**
var dt_camera_speed = 0;                                                                           // speed of the camera movement                                              **(can set in the Panel)**
var dt_max_terrain  = 0;                                                                           // set the highest point for moving vertices                                 **(can set in the Panel)**
var dt_min_terrain  = 0;                                                                           // set the deepest point for moving vertices                                 **(can set in the Panel)**
var dt_max_active   = 0;                                                                           // max limit for moving vertices is active / inactive                        **(can set in the Panel)**
var dt_min_active   = 0;                                                                           // min limit for moving vertices is active / inactive                        **(can set in the Panel)**
var dt_lod_vertices = 0;                                                                           // sets the distance where the verticesmarkers fade out                      **(can set in the Panel)**
var dt_high_terrain = 0;                                                                           // here ist the high of the Terrain in the middle of the selectet Vertices   **(shows up in the Panel)**

VECTOR DT_TEMP;                                                                                    // temporary vector
ANGLE DT_TEMP_ANG;

FONT* dt_font_16 = "Arial#16"; 
FONT* dt_font_25 = "Arial#25b"; 

STRING* DT_MAX_STR   = "#5";                                                                       // contains the max high of the vertexmove (have to be a text for the inkey...)
STRING* DT_MIN_STR   = "#5";
STRING* DT_INKEY_STR = "#100";
STRING* dt_path_save_ini = "dt_init.ini";

TEXT* DT_MAX_TXT   = {string = DT_MAX_STR;   font = dt_font_16;   red = 0;   green = 0;   blue = 0;   pos_x = 108;   pos_y = 553;   layer = 101;    flags = SHOW;}
TEXT* DT_MIN_TXT   = {string = DT_MIN_STR;   font = dt_font_16;   red = 0;   green = 0;   blue = 0;   pos_x = 108;   pos_y = 587;   layer = 101;    flags = SHOW;}
TEXT* DT_INKEY_TXT = {string = DT_INKEY_STR; font = dt_font_25;   red = 225; green = 0;   blue = 0;   pos_x = 0;     pos_y = 0;     layer = 103;} 

ENTITY* DT_DUMMY_ENT;                                                                              // entity behind the mouse from where the scan of vertices starts
ENTITY* DT_TERRAIN_ENT;                                                                            // the terrain that will be deform
ENTITY* DT_TERRAIN_NEAR_ENT;                                                                       // the terrain that will be spliced
ENTITY* DT_ALL_TERRAIN_ENT[dt_count_max_terrains];                                                 // pointer of all terrains

BMAP* dt_help_bmp;                                                                                 // temporary bmap pointers
BMAP* dt_splash_bmp;

BMAP* dt_cursor = "cursor1.tga";                                                                   //

#define dt_mode_flat        1                                                                      // that are the different modes for dt_mode....
#define dt_mode_pyramid     2
#define dt_mode_hill        3
#define dt_mode_smooth_hill 4
#define dt_mode_mountain    5
#define dt_mode_random      6
#define dt_mode_smooth      7
#define dt_mode_strong      8
#define dt_mode_make_flat   9

#define PRAGMA_PLUGIN "terrain_resave.dll"

BOOL dll_init_terrain();                                                                           // prototype of the dll
BOOL dll_load_terrain_from_entity (ENTITY* ent);
BOOL dll_save_terrain_from_entity (ENTITY* ent, STRING* nFl);
BOOL dll_close_terrain();

STRING* dll_path_from_entity( ENTITY* fl , BOOL b_get_absolute);
BOOL dll_path_set_subfolder( STRING* subfolder );

//*************************************************************************************************//

typedef struct                                                                                     // struct for every vertex marker
{
	VECTOR pos;
	
	int   vertex_id;                                                                                // stores the vertex number
	var   random_dt;                                                                                // stores a random value (-1 to 1)
	var   normalize;                                                                                // stores the distance to the mousepoint in the screen (0 till 1)
	BOOL  active;                                                                                   // stores if the Vertex is in the move mode
	short dist;                                                                                     // stores the distance to the middlepoint (Scandummy)
	
	var undo_1;                                                                                     // stores the high of the vertex at every step
	var undo_2;
	var undo_3;
	var undo_4;
	var undo_5;
	var undo_6;
	var undo_7;
	var undo_8;
	var undo_9;
	var undo_10;
} dt_marker;

dt_marker *DT_MARKER[dt_count_marker];                                                             //

//*************************************************************************************************//

void DT_ENTER()
{
	file_str_write (dt_fhandle,"
");
}

void DT_SPLASH(STRING* my_str,FONT* my_font)                                                       // create a splaspanel and remove it after showing
{
	char lines = 0;
	STRING* temp_str_1 = "";
	
	str_cpy (temp_str_1,my_str);                                                                    // how much lines have the string?
	while (result = str_stri (temp_str_1, "\n"))
	{
		lines ++;
		str_clip (temp_str_1,result);
	}
	
	result = str_width (my_str,dt_font_25);                                                         // the width of the string
	dt_splash_bmp = bmap_createblack(result + 30,lines * 25 + 40,32);
	bmap_fill (dt_splash_bmp,vector(0,0,0),70);
	PANEL* my_pan = pan_create ("bmap = dt_splash_bmp;   red = 255;   green = 0;   blue = 0", 102);
	my_pan.pos_x = (screen_size.x / 2) - (my_pan.size_x / 2);                                       // set the panel in the middle of the screen
	my_pan.pos_y = (screen_size.y / 2) - (my_pan.size_y / 2);
	pan_setdigits(my_pan,0,15,7,my_str,my_font,1,0);
	
	set (my_pan,SHOW);
	wait (-3);
	reset (my_pan,SHOW);
	
	ptr_remove (my_pan);
}

void DT_MOVE_PANEL(PANEL* my_pan)
{
	var dt_offset_x = mouse_pos.x - my_pan.pos_x;
	var dt_offset_y = mouse_pos.y - my_pan.pos_y;
	
	do                                                                                              // do this loop min once at the start from DEFORM TERRAIN to set the textpos and check the windowboarders
	{
		my_pan.pos_x = mouse_pos.x - dt_offset_x;
		my_pan.pos_y = mouse_pos.y - dt_offset_y;
		
		my_pan.pos_x = clamp (my_pan.pos_x,0,screen_size.x - my_pan.size_x);
		my_pan.pos_y = clamp (my_pan.pos_y,-100,screen_size.y - my_pan.size_y + 100);                // possible to move a little bit out of the screen for resolution.y = 600
		
		DT_MAX_TXT.pos_x = my_pan.pos_x + 88;                                                        // offset of the text
		DT_MAX_TXT.pos_y = my_pan.pos_y + 533;
		DT_MIN_TXT.pos_x = my_pan.pos_x + 88;
		DT_MIN_TXT.pos_y = my_pan.pos_y + 567;
		wait(1);
	}
	while (mouse_left);
}

void DT_HELP()                                                                                     // if not exist, create the help panel
{
	if (!dt_help_bmp)
	{
		dt_help_bmp = bmap_createblack (730,530,32);
		bmap_fill (dt_help_bmp,vector(200,200,200),80);
		DT_HELP_PAN = pan_create ("bmap = dt_help_bmp;   red = 255;   green = 0;   blue = 0", 102);
		DT_HELP_PAN.pos_x = (screen_size.x / 2) - (DT_HELP_PAN.size_x / 2);                          // set the panel in the middle of the screen
		DT_HELP_PAN.pos_y = (screen_size.y / 2) - (DT_HELP_PAN.size_y / 2);
		
		pan_setdigits(DT_HELP_PAN,0,20, 20,"* DEFORM TERRAIN *   by Markus Wiedenmeyer",font_create("Arial#35b"),1,0); 
		pan_setdigits(DT_HELP_PAN,0,20, 60,"- Be sure that your camera movement is stopped",font_create("Arial#25"),1,0); 
		pan_setdigits(DT_HELP_PAN,0,20, 90,"- Rotate camera with arrow keys",font_create("Arial#25"),1,0); 
		pan_setdigits(DT_HELP_PAN,0,20,120,"- Move camera forward / backward with W / S or with mousewheel",font_create("Arial#25"),1,0); 
		pan_setdigits(DT_HELP_PAN,0,20,150,"- Deform terrain with mouse left (up) or mouse right (down)",font_create("Arial#25"),1,0); 
		pan_setdigits(DT_HELP_PAN,0,20,180,"- Key 1 till key 9 is for the different deform modes (or use buttons)",font_create("Arial#25"),1,0); 
		pan_setdigits(DT_HELP_PAN,0,20,210,"- Key PgUp and key PgDn for change the deform size (or use the slider)",font_create("Arial#25"),1,0); 
		pan_setdigits(DT_HELP_PAN,0,20,240,"- Escape will end the DEFORM TERRAIN",font_create("Arial#25"),1,0); 
		pan_setdigits(DT_HELP_PAN,0,20,270,"- Backspace will undo the last step, till 10 steps (or use button)",font_create("Arial#25"),1,0); 
		pan_setdigits(DT_HELP_PAN,0,20,300,"- Ctrl will fix the selected vertices when mouse is moving",font_create("Arial#25"),1,0); 
		pan_setdigits(DT_HELP_PAN,0,20,330,"- HIGH shows the high of the middle of selected vertices",font_create("Arial#25"),1,0); 
		pan_setdigits(DT_HELP_PAN,0,20,360,"- You can move the edit window by Drag&Drop with the mouse",font_create("Arial#25"),1,0); 
		pan_setdigits(DT_HELP_PAN,0,20,390,"- MAX Z and MIN Z limits the vertices movement (if selected)",font_create("Arial#25"),1,0); 
		pan_setdigits(DT_HELP_PAN,0,20,420,"- F1 shows up this help window (or use button)",font_create("Arial#25"),1,0); 
		pan_setdigits(DT_HELP_PAN,0,20,450,"- F2 saves only the actually terrain (or use button)",font_create("Arial#25"),1,0); 
		pan_setdigits(DT_HELP_PAN,0,20,480,"- F3 splices the actually and the nearest terrains together (or use Button)",font_create("Arial#25"),1,0); 
		pan_setdigits(DT_HELP_PAN,0,600,510,"m-widi@bluewin.ch",font_create("Arial#15"),1,0);
	}
	
	set (DT_HELP_PAN,SHOW);
	while (mouse_left || key_f1)   wait(1);
	reset (DT_HELP_PAN,SHOW);
}

//*************************************************************************************************//

void DT_SAVE_TERRAIN()
{
	var my_inkey;                                                                                   // stores the scancode from the inkey
	long my_size;
	STRING* temp_str_1 = "#100";
	STRING* temp_str_2 = "#100";
	
	c_updatehull (DT_TERRAIN_ENT,1);
	ent_fixnormals (DT_TERRAIN_ENT,1);
	
	dll_init_terrain();                                                                             // init the terrain dll
	dll_path_set_subfolder(_str(""));
	temp_str_1 = dll_path_from_entity(DT_TERRAIN_ENT,FALSE);
	str_cpy (DT_INKEY_STR,temp_str_1);
	
	dt_splash_bmp = bmap_createblack(500,45,32);                                                    // create a panel
	bmap_fill (dt_splash_bmp,vector(0,0,0),70);
	PANEL* my_pan = pan_create ("bmap = dt_splash_bmp;   red = 255;   green = 0;   blue = 0", 102);
	my_pan.pos_x = (screen_size.x / 2) - (my_pan.size_x / 2);
	my_pan.pos_y = (screen_size.y / 2) - (my_pan.size_y / 2);
	
	DT_INKEY_TXT.pos_x = screen_size.x / 2 - 235;                                                   // set the text pos
	DT_INKEY_TXT.pos_y = screen_size.y / 2 - 12;
	str_trunc (DT_INKEY_STR,4);                                                                     // cut the ".hmp"
	set (my_pan,SHOW);
	set (DT_INKEY_TXT,SHOW);
	my_inkey = inkey (DT_INKEY_STR);
	reset (my_pan,SHOW);
	reset (DT_INKEY_TXT,SHOW);
	str_cat (DT_INKEY_STR,".hmp");
	
	ptr_remove (my_pan);
	
	str_cpy (temp_str_1,DT_INKEY_STR);                                                              // replace all "\" with "\\"
	str_cpy (DT_INKEY_STR,"");
	while (result = str_stri (temp_str_1, "\\"))
	{
		str_cpy (temp_str_2,temp_str_1);
		str_clip (temp_str_1,result);
		str_trunc (temp_str_2,str_len(temp_str_2) - result);
		str_cat (DT_INKEY_STR,temp_str_2);
		str_cat (DT_INKEY_STR,"\\");
	}
	str_cat (DT_INKEY_STR,temp_str_1);
	
	if (my_inkey == 13)                                                                             // if inkey terminates with "enter"
	{
		if (file_exists (DT_INKEY_STR))                                                              // make a *.bak if the terrain already exists
		{
			str_cpy (temp_str_1,DT_INKEY_STR);
			void* pTerrain = file_load (temp_str_1,NULL,&my_size);                                    // load the exists terrain into the buffer...
			add_buffer (temp_str_1,pTerrain,my_size);
			str_trunc (temp_str_1,3);                                                                 // ...replace hmp with bak...
			str_cat (temp_str_1,"bak");
			file_save (temp_str_1,pTerrain,my_size);                                                  // ...and save it
			
			file_load(NULL,pTerrain,NULL);                                                            // free the buffer
		}
		
		for (dt_vertex_nr = 1; dt_vertex_nr <= dt_vertices; dt_vertex_nr ++)                         // convert to world coordinates...
		{
			CONTACT* c = ent_getvertex(DT_TERRAIN_ENT,NULL,dt_vertex_nr);
			c.v.y += DT_TERRAIN_ENT.z;
			ent_setvertex(DT_TERRAIN_ENT,c,dt_vertex_nr);
		}
		
		dll_load_terrain_from_entity(DT_TERRAIN_ENT);                                                // save the terrain
		result = dll_save_terrain_from_entity(DT_TERRAIN_ENT,DT_INKEY_STR);
		if (result == 1)  DT_SPLASH("Saved",dt_font_25);
		else              DT_SPLASH("Error 01: Terrain is NOT saved",dt_font_25);
		
		for (dt_vertex_nr = 1; dt_vertex_nr <= dt_vertices; dt_vertex_nr ++)                         // ...and convert back to entity coordinates
		{
			CONTACT* c = ent_getvertex(DT_TERRAIN_ENT,NULL,dt_vertex_nr);
			c.v.y -= DT_TERRAIN_ENT.z;
			ent_setvertex(DT_TERRAIN_ENT,c,dt_vertex_nr);
		}
	}
	dll_close_terrain();
}

void DT_END()
{
	dt_fhandle = file_open_write(dt_path_save_ini);
	file_str_write(dt_fhandle,"INI DAT FOR \"DEFORM TERRAIN\":");   DT_ENTER();   DT_ENTER();
	file_str_write(dt_fhandle,"dt_mode            = ");   file_var_write(dt_fhandle,dt_mode);              DT_ENTER();
	file_str_write(dt_fhandle,"dt_scan_radius     = ");   file_var_write(dt_fhandle,dt_scan_radius);       DT_ENTER();
	file_str_write(dt_fhandle,"dt_vertex_speed    = ");   file_var_write(dt_fhandle,dt_vertex_speed);      DT_ENTER();
	file_str_write(dt_fhandle,"dt_camera_speed    = ");   file_var_write(dt_fhandle,dt_camera_speed);      DT_ENTER();
	file_str_write(dt_fhandle,"dt_lod_vertices    = ");   file_var_write(dt_fhandle,dt_lod_vertices);      DT_ENTER();
	file_str_write(dt_fhandle,"dt_max_active      = ");   file_var_write(dt_fhandle,dt_max_active);        DT_ENTER();
	file_str_write(dt_fhandle,"dt_min_active      = ");   file_var_write(dt_fhandle,dt_min_active);        DT_ENTER();
	file_str_write(dt_fhandle,"dt_max_terrain     = ");   file_var_write(dt_fhandle,dt_max_terrain);       DT_ENTER();
	file_str_write(dt_fhandle,"dt_min_terrain     = ");   file_var_write(dt_fhandle,dt_min_terrain);       DT_ENTER();
	file_str_write(dt_fhandle,"DT_PANEL_PAN.pos_x = ");   file_var_write(dt_fhandle,DT_PANEL_PAN.pos_x);   DT_ENTER();
	file_str_write(dt_fhandle,"DT_PANEL_PAN.pos_y = ");   file_var_write(dt_fhandle,DT_PANEL_PAN.pos_y);   DT_ENTER();
	file_close (dt_fhandle);
	
	dt_vertex_nr = 1;
	while (DT_MARKER[dt_vertex_nr])
	{
		sys_free (DT_MARKER[dt_vertex_nr]);
		dt_vertex_nr ++;
	}
	
	sys_exit("");
}

void DT_CHANGE_RADIUS(scancode)                                                                    // key pgup and pgdn
{
	while (key_pgup || key_pgdn)
	{
		if (scancode == 73)   {dt_scan_radius += 5 * time_step;   dt_scan_radius = minv(dt_scan_radius,999);}
		else                  {dt_scan_radius -= 5 * time_step;   dt_scan_radius = maxv(dt_scan_radius,10);}
		wait(1);
	}
}

void DT_MODE_NUMBER(number)                                                                        // key or button 1 till 9, set differents dt_mode
{
	if (mouse_left)  {dt_mode = number;}
	else             {dt_mode = number - 1;   button_state(DT_PANEL_PAN,number - 1,1);}
}

//*************************************************************************************************//

void DT_SWITCH_TERRAIN()
{
	char counter;
	var dist = 1000000;
	you = DT_TERRAIN_ENT;
	
	for (counter = 0; counter < dt_count_terrain; counter ++)                                       // search the nearest terrain
	{
		result = vec_dist(camera.x,DT_ALL_TERRAIN_ENT[counter].x);
		if (result < dist)
		{
			DT_TERRAIN_ENT = DT_ALL_TERRAIN_ENT[counter];
			dist = result;
		}
	}
	
	if (you != DT_TERRAIN_ENT)                                                                      // if another terrain is detected...
	{
		dt_count_steps = 0;                                                                          // erase all UNDO positions
		
		dt_vertices = ent_status(DT_TERRAIN_ENT,0);                                                  // gives the new count of vertices
		dt_terr_x   = ent_status(DT_TERRAIN_ENT,2) + 1;                                              // count of vertices in x direction
		dt_terr_y   = ent_status(DT_TERRAIN_ENT,3) + 1;                                              // count of vertices in y direction
		
		for (dt_vertex_nr = 1; dt_vertex_nr <= dt_vertices; dt_vertex_nr ++)                         // create a vertexmarker at every vertex
		{
			CONTACT* c = ent_getvertex(DT_TERRAIN_ENT,NULL,dt_vertex_nr);
			c.v = NULL;
			vec_for_ent (c.x, DT_TERRAIN_ENT);
			
			if (!DT_MARKER[dt_vertex_nr])   DT_MARKER[dt_vertex_nr] = sys_malloc(sizeof(dt_marker)); 
			vec_set (DT_MARKER[dt_vertex_nr].pos.x,c.x);
			DT_MARKER[dt_vertex_nr].vertex_id = dt_vertex_nr;
			DT_MARKER[dt_vertex_nr].active = 0;
		}
	}
}

void DT_SPLICES_TERRAINS()
{
	var counter;
	var dist = 1000000;
	STRING* temp_str_1 = "";
	STRING* temp_str_2 = "";
	
	if (dt_count_terrain < 2)                                                                       // no one terrain with skill99 = 100
	{
		DT_SPLASH("only one terrain detect. Not possible to splice",dt_font_25);
		wait_for (DT_SPLASH);
		return;
	}
	
	for (counter = 0; counter < dt_count_terrain; counter ++)                                       // search the nearest terrain
	{
		result = vec_dist(camera.x,DT_ALL_TERRAIN_ENT[counter].x);
		if (result < dist && DT_ALL_TERRAIN_ENT[counter] != DT_TERRAIN_ENT)
		{
			DT_TERRAIN_NEAR_ENT = DT_ALL_TERRAIN_ENT[counter];
			dist = result;
		}
	}
	
	if (dt_terr_x != ent_status(DT_TERRAIN_NEAR_ENT,2) + 1 || dt_terr_y != ent_status(DT_TERRAIN_NEAR_ENT,3) + 1)
	{
		DT_SPLASH("The terrains don`t have the same size.\n             Not possible to splice",dt_font_25);
		wait_for (DT_SPLASH);
		return;
	}
	
	DT_SAVE_STEP(0);
	
	str_cpy (temp_str_1,"You want to splice\n");
	str_for_entfile(temp_str_2,DT_TERRAIN_ENT);
	str_trunc (temp_str_2,4);
	str_cat (temp_str_1,temp_str_2);
	str_cat (temp_str_1,"\nwith\n");
	str_for_entfile(temp_str_2,DT_TERRAIN_NEAR_ENT);
	str_trunc (temp_str_2,4);
	str_cat (temp_str_1,temp_str_2);
	str_cat (temp_str_1," ?\n\nPress ESC to abort or ENTER to continue");
	
	while (key_any)   wait(1);
	
	result = str_width (temp_str_1,dt_font_25);
	dt_splash_bmp = bmap_createblack(result + 30,165,32);
	bmap_fill (dt_splash_bmp,vector(0,0,0),70);
	PANEL* my_pan = pan_create ("bmap = dt_splash_bmp;   red = 255;   green = 0;   blue = 0", 102);
	my_pan.pos_x = (screen_size.x / 2) - (my_pan.size_x / 2);
	my_pan.pos_y = (screen_size.y / 2) - (my_pan.size_y / 2);
	pan_setdigits(my_pan,0,15,7,temp_str_1,dt_font_25,1,0);
	
	set (my_pan,SHOW);
	result = inchar(temp_str_2);
	reset (my_pan,SHOW);
	ptr_remove (my_pan);
	if (result != 13)   return;                                                                     // if not ENTER was pressed
	
	if (DT_TERRAIN_NEAR_ENT.x > DT_TERRAIN_ENT.x + DT_TERRAIN_ENT.max_x)                            // the second terrain is on the right side
	{
		for (counter = 0; counter < dt_vertices; counter += dt_terr_x)                               // 
		{
			CONTACT* c = ent_getvertex(DT_TERRAIN_NEAR_ENT,NULL,counter + 1);
			dist = c.v.y;
			CONTACT* c = ent_getvertex(DT_TERRAIN_ENT,NULL,counter + dt_terr_x);
			c.v.y = dist;
			ent_setvertex(DT_TERRAIN_ENT,c,counter + dt_terr_x);
			DT_MARKER[counter + dt_terr_x].pos.z = dist + DT_TERRAIN_ENT.z;
		}
	}
	
	if (DT_TERRAIN_NEAR_ENT.x < DT_TERRAIN_ENT.x + DT_TERRAIN_ENT.min_x)                            // the second terrain is on the left side
	{
		for (counter = 0; counter < dt_vertices; counter += dt_terr_x)                               // 
		{
			CONTACT* c = ent_getvertex(DT_TERRAIN_NEAR_ENT,NULL,counter + dt_terr_x);
			dist = c.v.y;
			CONTACT* c = ent_getvertex(DT_TERRAIN_ENT,NULL,counter + 1);
			c.v.y = dist;
			ent_setvertex(DT_TERRAIN_ENT,c,counter + 1);
			DT_MARKER[counter + 1].pos.z = dist + DT_TERRAIN_ENT.z;
		}
	}
	
	if (DT_TERRAIN_NEAR_ENT.y > DT_TERRAIN_ENT.y + DT_TERRAIN_ENT.max_y)                            // the second terrain is on the bottom side
	{
		for (counter = 1; counter <= dt_terr_x; counter ++)                                          // 
		{
			CONTACT* c = ent_getvertex(DT_TERRAIN_NEAR_ENT,NULL,dt_vertices - dt_terr_x + counter);
			dist = c.v.y;
			CONTACT* c = ent_getvertex(DT_TERRAIN_ENT,NULL,counter + 0);
			c.v.y = dist;
			ent_setvertex(DT_TERRAIN_ENT,c,counter + 0);
			DT_MARKER[counter].pos.z = dist + DT_TERRAIN_ENT.z;
		}
	}
	
	if (DT_TERRAIN_NEAR_ENT.y < DT_TERRAIN_ENT.y + DT_TERRAIN_ENT.min_y)                            // the second terrain is on the top side
	{
		for (counter = 1; counter <= dt_terr_x; counter ++)                                          // 
		{
			CONTACT* c = ent_getvertex(DT_TERRAIN_NEAR_ENT,NULL,counter + 0);
			dist = c.v.y;
			CONTACT* c = ent_getvertex(DT_TERRAIN_ENT,NULL,dt_vertices - dt_terr_x + counter);
			c.v.y = dist;
			ent_setvertex(DT_TERRAIN_ENT,c,dt_vertices - dt_terr_x + counter);
			DT_MARKER[dt_vertices - dt_terr_x + counter].pos.z = dist + DT_TERRAIN_ENT.z;
		}
	}
	c_updatehull(DT_TERRAIN_ENT,1);
}

//-------------------------------------------------------------------------------------------------//

void DT_SAVE_STEP(Scancode)                                                                        // saves at every transformbeginning the high of a vertexmarker
{
	inkey_active = 0;                                                                               // if the inkey from dt_max_high or dt_min_high is still active --> reset it
	if (Scancode > 0 && mouse_panel != NULL)   return;                                              // if this function is called with a mouseclick and the mouse is over a panel --> don`t save the step
	
	dt_count_steps ++;
	dt_count_steps = minv(dt_count_steps,9);
	
	for (dt_vertex_nr = 1; dt_vertex_nr <= dt_vertices; dt_vertex_nr ++)                            // move all position.z one undo pos up...
	{
		DT_MARKER[dt_vertex_nr].undo_10 = DT_MARKER[dt_vertex_nr].undo_9;
		DT_MARKER[dt_vertex_nr].undo_9  = DT_MARKER[dt_vertex_nr].undo_8;
		DT_MARKER[dt_vertex_nr].undo_8  = DT_MARKER[dt_vertex_nr].undo_7;
		DT_MARKER[dt_vertex_nr].undo_7  = DT_MARKER[dt_vertex_nr].undo_6;
		DT_MARKER[dt_vertex_nr].undo_6  = DT_MARKER[dt_vertex_nr].undo_5;
		DT_MARKER[dt_vertex_nr].undo_5  = DT_MARKER[dt_vertex_nr].undo_4;
		DT_MARKER[dt_vertex_nr].undo_4  = DT_MARKER[dt_vertex_nr].undo_3;
		DT_MARKER[dt_vertex_nr].undo_3  = DT_MARKER[dt_vertex_nr].undo_2;
		DT_MARKER[dt_vertex_nr].undo_2  = DT_MARKER[dt_vertex_nr].undo_1;
		DT_MARKER[dt_vertex_nr].undo_1  = DT_MARKER[dt_vertex_nr].pos.z;                             // ...and save the present pos.z
	}
	
	while (mouse_left || mouse_right)  wait(1);                                                     // if deform is finish, after release the mouse set the hull new (needed for c_trace gives the new position)
	wait(1);
	c_updatehull(DT_TERRAIN_ENT,1);
}

void DT_UNDO()
{
	if (dt_count_steps > 0)                                                                         // if have already a stored position
	{
		for (dt_vertex_nr = 1; dt_vertex_nr <= dt_vertices; dt_vertex_nr ++)
		{
			CONTACT* c = ent_getvertex(DT_TERRAIN_ENT,NULL,dt_vertex_nr);                             // set the vertex at the stored position...
			c.v.y = DT_MARKER[dt_vertex_nr].undo_1 - DT_TERRAIN_ENT.z;
			DT_MARKER[dt_vertex_nr].pos.z = DT_MARKER[dt_vertex_nr].undo_1;
			ent_setvertex(DT_TERRAIN_ENT,c,dt_vertex_nr);
			
			DT_MARKER[dt_vertex_nr].undo_1 = DT_MARKER[dt_vertex_nr].undo_2;                          // ...and move all position.z one undo pos down
			DT_MARKER[dt_vertex_nr].undo_2 = DT_MARKER[dt_vertex_nr].undo_3;
			DT_MARKER[dt_vertex_nr].undo_3 = DT_MARKER[dt_vertex_nr].undo_4;
			DT_MARKER[dt_vertex_nr].undo_4 = DT_MARKER[dt_vertex_nr].undo_5;
			DT_MARKER[dt_vertex_nr].undo_5 = DT_MARKER[dt_vertex_nr].undo_6;
			DT_MARKER[dt_vertex_nr].undo_6 = DT_MARKER[dt_vertex_nr].undo_7;
			DT_MARKER[dt_vertex_nr].undo_7 = DT_MARKER[dt_vertex_nr].undo_8;
			DT_MARKER[dt_vertex_nr].undo_8 = DT_MARKER[dt_vertex_nr].undo_9;
			DT_MARKER[dt_vertex_nr].undo_9 = DT_MARKER[dt_vertex_nr].undo_10;
			DT_MARKER[dt_vertex_nr].undo_10 = 0;
		}
		dt_count_steps --;
		wait(1);
		c_updatehull(DT_TERRAIN_ENT,1);                                                              // after Undo set the hull new (needed for c_trace gives the new position)
	}
}

//-------------------------------------------------------------------------------------------------//

void DT_VERTEX_MOVE(dt_marker* my_struct)                                                          // set the vertexposition to the vertexmarker position
{
	CONTACT* c = ent_getvertex(DT_TERRAIN_ENT,NULL,my_struct.vertex_id);
	c.v.y = my_struct.pos.z - DT_TERRAIN_ENT.z;
	ent_setvertex(DT_TERRAIN_ENT,c,my_struct.vertex_id);				
}

void DT_VERTEX_MOVE_FLAT(dt_marker* my_struct,direction)                                           // the different movemodes...
{
	my_struct.pos.z += direction;
}

void DT_VERTEX_MOVE_PYRAMID(dt_marker* my_struct,direction)
{
	my_struct.pos.z += my_struct.normalize * direction;
}

void DT_VERTEX_MOVE_HILL(dt_marker* my_struct,direction)
{
	my_struct.pos.z += sinv(my_struct.normalize * 90) * direction;
}

void DT_VERTEX_MOVE_SMOOTH_HILL(dt_marker* my_struct,direction)
{
	if (my_struct.normalize < 0.5)   my_struct.pos.z += ((my_struct.normalize - (sinv(my_struct.normalize * 180) / 2)) + my_struct.normalize) * direction;
	else                             my_struct.pos.z += ((((sinv((my_struct.normalize - 0.5) * 180) / 2) + 0.5) - my_struct.normalize) + my_struct.normalize) * direction;
}

void DT_VERTEX_MOVE_MOUNTAIN(dt_marker* my_struct,direction)
{
	my_struct.pos.z += (my_struct.normalize - (sinv(my_struct.normalize * 90) - my_struct.normalize)) * direction;
}

void DT_VERTEX_MOVE_RANDOM(dt_marker* my_struct,direction)
{
	my_struct.pos.z += my_struct.random_dt * direction;
}

void DT_VERTEX_MOVE_SMOOTH_STRONG(dt_marker* my_struct)
{
	var counter = 2;
	var high = my_struct.pos.z * 2;                                                                 // the middle vertex counts twice
	BOOL upper_border = 0;
	BOOL lower_border = 0;
	BOOL right_border = 0;
	BOOL left_border  = 0;
	
	if (my_struct.vertex_id > dt_terr_x)                  {counter ++;   high += DT_MARKER[my_struct.vertex_id - dt_terr_x].pos.z;   upper_border = 1;}   // not at the upper boarder
	if (my_struct.vertex_id <= dt_vertices - dt_terr_x)   {counter ++;   high += DT_MARKER[my_struct.vertex_id + dt_terr_x].pos.z;   lower_border = 1;}   // not at the lower boarder
	if (fraction(my_struct.vertex_id / dt_terr_x))        {counter ++;   high += DT_MARKER[my_struct.vertex_id + 1].pos.z;           right_border = 1;}   // not at the right boarder
	if (fraction((my_struct.vertex_id - 1) / dt_terr_x))  {counter ++;   high += DT_MARKER[my_struct.vertex_id - 1].pos.z;           left_border  = 1;}   // not at the left boarder
	
	if (upper_border && left_border)    {counter += 0.8;   high += DT_MARKER[my_struct.vertex_id - dt_terr_x - 1].pos.z * 0.8;}
	if (upper_border && right_border)   {counter += 0.8;   high += DT_MARKER[my_struct.vertex_id - dt_terr_x + 1].pos.z * 0.8;}
	if (lower_border && left_border)    {counter += 0.8;   high += DT_MARKER[my_struct.vertex_id + dt_terr_x - 1].pos.z * 0.8;}
	if (lower_border && right_border)   {counter += 0.8;   high += DT_MARKER[my_struct.vertex_id + dt_terr_x + 1].pos.z * 0.8;}
	
	if (dt_mode == dt_mode_smooth)   my_struct.pos.z -= (my_struct.pos.z - (high / counter)) / 100 * dt_vertex_speed;
	else                             my_struct.pos.z += (my_struct.pos.z - (high / counter)) / 100 * dt_vertex_speed;
}

void DT_VERTEX_MOVE_MAKE_FLAT(dt_marker* my_struct)
{
	my_struct.pos.z = DT_DUMMY_ENT.z;
}

//-------------------------------------------------------------------------------------------------//

void DT_VERTEX_POINTER_ACTIVE(dt_marker* my_struct)
{
	my_struct.active = 1;
	my_struct.dist = vec_dist(vector(my_struct.pos.x,my_struct.pos.y,0),vector(you.x,you.y,0));
	                                                                                                // distance to the scandummy (without .z, a bit faster then vec_dist)
	while (my_struct.dist < dt_scan_radius)
	{
		my_struct.normalize = (dt_scan_radius - my_struct.dist) / dt_scan_radius;                    // for div movement, gives a valvue from 0 till 1
		if (!mouse_left && !mouse_right)   my_struct.random_dt = random(2) - 1;                      // for random movement, gives a valvue from 0 till 1
		
		if (mouse_left && !mouse_panel && !dt_pan_active)                                            // move vertices up
		{
			wait(1);                                                                                  // wait at the beginning, give time to save the undo positions
			switch (dt_mode)
			{
				case dt_mode_flat:          DT_VERTEX_MOVE_FLAT(my_struct,dt_vertex_speed * time_step);          break;   
				case dt_mode_pyramid:       DT_VERTEX_MOVE_PYRAMID(my_struct,dt_vertex_speed * time_step);       break;   
				case dt_mode_hill:          DT_VERTEX_MOVE_HILL(my_struct,dt_vertex_speed * time_step);          break;   
				case dt_mode_smooth_hill:   DT_VERTEX_MOVE_SMOOTH_HILL(my_struct,dt_vertex_speed * time_step);   break;   
				case dt_mode_mountain:      DT_VERTEX_MOVE_MOUNTAIN(my_struct,dt_vertex_speed * time_step);      break;   
				case dt_mode_random:        DT_VERTEX_MOVE_RANDOM(my_struct,dt_vertex_speed * time_step / 2);    break;   
				case dt_mode_smooth:        DT_VERTEX_MOVE_SMOOTH_STRONG(my_struct);                             break;   
				case dt_mode_strong:        DT_VERTEX_MOVE_SMOOTH_STRONG(my_struct);                             break;   
				case dt_mode_make_flat:     DT_VERTEX_MOVE_MAKE_FLAT(my_struct);                                 break;   
			}
			if (dt_max_active && my_struct.pos.z > dt_max_terrain)   my_struct.pos.z = dt_max_terrain;
			DT_VERTEX_MOVE(my_struct);                                                                // move the real vertex from the terrain
		}
		
		if (mouse_right && !mouse_panel && !dt_pan_active)                                           // move vertices down
		{
			wait(1);                                                                                  // wait at the beginning, give time to save the undo positions
			switch (dt_mode)
			{
				case dt_mode_flat:          DT_VERTEX_MOVE_FLAT(my_struct,-dt_vertex_speed * time_step);          break;   
				case dt_mode_pyramid:       DT_VERTEX_MOVE_PYRAMID(my_struct,-dt_vertex_speed * time_step);       break;   
				case dt_mode_hill:          DT_VERTEX_MOVE_HILL(my_struct,-dt_vertex_speed * time_step);          break;   
				case dt_mode_smooth_hill:   DT_VERTEX_MOVE_SMOOTH_HILL(my_struct,-dt_vertex_speed * time_step);   break;   
				case dt_mode_mountain:      DT_VERTEX_MOVE_MOUNTAIN(my_struct,-dt_vertex_speed * time_step);      break;   
				case dt_mode_random:        DT_VERTEX_MOVE_RANDOM(my_struct,-dt_vertex_speed * time_step / 2);    break;   
				case dt_mode_smooth:        DT_VERTEX_MOVE_SMOOTH_STRONG(my_struct);                              break;   
				case dt_mode_strong:        DT_VERTEX_MOVE_SMOOTH_STRONG(my_struct);                              break;   
				case dt_mode_make_flat:     DT_VERTEX_MOVE_MAKE_FLAT(my_struct);                                  break;   
			}
			if (dt_min_active && my_struct.pos.z < dt_min_terrain)   my_struct.pos.z = dt_min_terrain;
			DT_VERTEX_MOVE(my_struct);                                                                // move the real vertex from the terrain
		}
		if (!mouse_left && !mouse_right || mouse_panel || dt_pan_active)   wait(1);
		my_struct.dist = vec_dist(vector(my_struct.pos.x,my_struct.pos.y,0),vector(you.x,you.y,0));  // the new distance to the scandummy
	}
	my_struct.active = 0;
}

void DT_SCAN_VERTICES()
{
	you = DT_DUMMY_ENT;
	for (dt_vertex_nr = 1; dt_vertex_nr <= dt_vertices; dt_vertex_nr ++)
	{
		if (DT_MARKER[dt_vertex_nr].pos.x < you.x + dt_scan_radius && DT_MARKER[dt_vertex_nr].pos.x > you.x - dt_scan_radius
		&& DT_MARKER[dt_vertex_nr].pos.y < you.y + dt_scan_radius && DT_MARKER[dt_vertex_nr].pos.y > you.y - dt_scan_radius 
		&& !DT_MARKER[dt_vertex_nr].active)                                                          // not all vertices are checked with vec_dist, --> faster
		{
			if(vec_dist(vector(DT_MARKER[dt_vertex_nr].pos.x,DT_MARKER[dt_vertex_nr].pos.y,0),vector(you.x,you.y,0)) < dt_scan_radius) 
			{
				DT_VERTEX_POINTER_ACTIVE(DT_MARKER[dt_vertex_nr]);                                     // if the marker is in the scanradius set it to the movemode (red)
			}
		}
		if (DT_MARKER[dt_vertex_nr].pos.x < camera.x + mouse_range && DT_MARKER[dt_vertex_nr].pos.x > camera.x - mouse_range
		&& DT_MARKER[dt_vertex_nr].pos.y < camera.y + mouse_range && DT_MARKER[dt_vertex_nr].pos.y > camera.y - mouse_range)   // not all vertices are checked with vec_dist, --> faster
		{
			if (vec_dist(DT_MARKER[dt_vertex_nr].pos.x,camera.x) < mouse_range)
			{
				if (DT_MARKER[dt_vertex_nr].active)   draw_point3d(DT_MARKER[dt_vertex_nr].pos.x,vector(0,0  ,255),100,5 * dt_scale_marker);
				else                                  draw_point3d(DT_MARKER[dt_vertex_nr].pos.x,vector(0,255,255),100,5 * dt_scale_marker);
			}
		}
	}
	dt_high_terrain = DT_DUMMY_ENT.z;
}

void DT_SCAN_DUMMY()
{
	var high = 0;
	var dist;
	
	wait(1);                                                                                        // wait untill the vertexmarker exists
	set (my,INVISIBLE | PASSABLE);
	set (my,PASSABLE);
	
	while(1)
	{
		DT_TEMP.x = mouse_pos.x;                                                                     // trace from the mouse to the terrain behind the mouse
		DT_TEMP.y = mouse_pos.y;
		DT_TEMP.z = mouse_range;
		vec_for_screen (DT_TEMP,camera);
		result = c_trace (camera.x,DT_TEMP,IGNORE_ME | IGNORE_PASSABLE);
		
		if (!key_ctrl)                                                                               // don`t move if key_ctrl is pressed
		{
			if (you)                                                                                  // if trace hits a terrain
			{
				high = my.z;
				vec_set (my.x,target);
				if (mouse_left || mouse_right)  my.z = DT_MARKER[ent_nextvertex (DT_TERRAIN_ENT,my.x)].pos.z;
			} else {
				result = c_trace (camera.x,vector(camera.x,camera.y,camera.z - 10000),IGNORE_PASSABLE);
				if (you)
				{
					vec_diff (DT_TEMP,DT_TEMP,camera.x);
					vec_to_angle (DT_TEMP_ANG,DT_TEMP);
					if (DT_TEMP_ANG.tilt > -1)   DT_TEMP_ANG.tilt = -1;                                 // if tilt near 0 gives a too big distance --> error
					result = camera.z - high;
					dist = (camera.z - high) / sin(-DT_TEMP_ANG.tilt);
					dist = minv(dist,mouse_range + dt_scan_radius);
					DT_TEMP.x = mouse_pos.x;                                                            // set the DT_TEMP new with the range of dist
					DT_TEMP.y = mouse_pos.y;
					DT_TEMP.z = dist;
					vec_for_screen (DT_TEMP,camera);
					vec_set (my.x,DT_TEMP);
					my.z = high;
				}
			}
		}
		DT_SCAN_VERTICES();
		draw_point3d(my.x,vector(0,255,0),100,4 * dt_scale_marker);
		wait(1);
	}
}

void DT_CAMERA()                                                                                   // camera movement
{
	vec_set (my.pan,DT_TEMP_ANG);
	set (my,INVISIBLE | PASSABLE);
	
	DT_DUMMY_ENT = ent_create("Wuerfel_0.mdl",player.x,DT_SCAN_DUMMY);                              // creates a dummy for scans the vertices marker at the terrain
	
	while(1)
	{
		if (key_w || key_s || mickey.z)   DT_SWITCH_TERRAIN();                                       // test if the camera stay nearly another terrain
		c_move(my,vector((key_w - key_s) * dt_camera_speed * time_step + (mickey.z / 30 * dt_camera_speed * time_step),0,0),NULL,IGNORE_MAPS);
		c_rotate(my,vector(-key_force.x * (dt_camera_speed / 10) * time_step,key_force.y * (dt_camera_speed / 10) * time_step,0),IGNORE_MAPS);
		my.tilt = clamp(my.tilt,-90,90);
		vec_set (camera.x,my.x);
		vec_set (camera.pan,my.pan);
		
		mouse_pos.x += mouse_force.x * dt_mouse_speed * time_step;
		mouse_pos.y -= mouse_force.y * dt_mouse_speed * time_step;
		
		if (video_screen == 2)   
			SetCursorPos (screen_size.x / 2 + window_pos.x,screen_size.y / 2 + window_pos.y);         // Set the Windows mouse in the middle of the screen (behind the engine window)
		
		mouse_range = camera.clip_far / 100 * dt_lod_vertices;
		
		if (mouse_panel == DT_PANEL_PAN && mouse_left)    dt_pan_active = 1;                         // for move the panel and press a button, vertices no move more now
		if (mouse_panel != DT_PANEL_PAN && !mouse_left)   dt_pan_active = 0;                         // vertices can now move again
		
		wait(1);
	}
}

//*************************************************************************************************//

void DT_EDIT_TERRAIN()
{
	STRING* DT_TEMP_STR = "#1000";
	
	you = ent_next(NULL);                                                                           // retrieve first entity
	while (you)                                                                                     // repeat until there are no more entities
	{
		if (you.dt_terrain_skill == dt_skill_value && ent_type(you) == 4)                            // make a test if one terrain is in the level or they are to much or big terrains
		{
			if ((ent_status(you,2) + 1) * (ent_status(you,3) + 1) >= dt_count_marker)
			{
				DT_SPLASH("                    Terrain is to big.\nIncrease \"dt_count_marker\" in the script",dt_font_25);
				wait_for (DT_SPLASH);
				return;
			}
			if (dt_count_terrain == dt_count_max_terrains)
			{
				DT_SPLASH("                        To much terrains.\nIncrease \"dt_count_max_terrains\" in the script",dt_font_25);
				wait_for (DT_SPLASH);
				return;
			}
			dt_count_terrain ++;
		}
		you = ent_next(you);                                                                         // get next entity
	}
	
	if (!dt_count_terrain)                                                                          // no one terrain with skill99 = 100
	{
		DT_SPLASH("Found no terrain. Set skill99 to 100 at all your terrains",dt_font_25);
		wait_for (DT_SPLASH);
		return;
	}
	
	if (!GetModuleHandle("terrain_resave.dll"))                                                     // is the dll included?
	{
		DT_SPLASH("DLL terrain_resave.dll is not located. Make sure it\n    is in the subfolder: Plugin\\terrain_resave.dll",dt_font_25);
		wait_for (DT_SPLASH);
		return;
	}
	
	vec_set (DT_TEMP,camera.x);
	vec_set (DT_TEMP_ANG,camera.pan);
	
	if (max_particles < dt_more_particle || terrain_lod || terrain_chunk)                           // reload the terrain, set lod and chunk and particles...
	{
		str_cpy (DT_TEMP_STR,"Level will be reload, please wait.\n\nterrain_lod = 0;\nterrain_chunk = 0;\nmax_particles = dt_more_particle;\nlevel_load \"");
		str_cat (DT_TEMP_STR,level_name);
		str_cat (DT_TEMP_STR,"\";");
		DT_SPLASH(DT_TEMP_STR,dt_font_25);
		wait(-2.5);
		terrain_lod = 0;
		terrain_chunk = 0;
		max_particles += dt_more_particle;                                                           // every vertexmarker is a particle
		level_load (level_name);
		wait(3);
	}
	
	on_f1          = DT_HELP;
	on_f2          = DT_SAVE_TERRAIN;
	on_f3          = DT_SPLICES_TERRAINS;
	on_mouse_right = DT_SAVE_STEP;
	on_mouse_left  = DT_SAVE_STEP;
	on_cuu         = NULL;
	on_cud         = NULL;
	on_cul         = NULL;
	on_cur         = NULL;
	on_esc         = DT_END;
	on_pgup        = DT_CHANGE_RADIUS;
	on_pgdn        = DT_CHANGE_RADIUS;
	on_bksp        = DT_UNDO;
	on_ctrl        = NULL;
	on_s           = NULL;
	on_w           = NULL;
	
	on_1           = DT_MODE_NUMBER;
	on_2           = DT_MODE_NUMBER;
	on_3           = DT_MODE_NUMBER;
	on_4           = DT_MODE_NUMBER;
	on_5           = DT_MODE_NUMBER;
	on_6           = DT_MODE_NUMBER;
	on_7           = DT_MODE_NUMBER;
	on_8           = DT_MODE_NUMBER;
	on_9           = DT_MODE_NUMBER;
	
	dt_count_terrain = 0;
	you = ent_next(NULL);                                                                           // retrieve first entity
	while (you)                                                                                     // repeat until there are no more entities
	{
		if (you.dt_terrain_skill < dt_skill_value)   ptr_remove (you);                               // remove all other entities
		you = ent_next(you);                                                                         // get next entity
	}
	
	wait(1);
	
	you = ent_next(NULL);                                                                           // retrieve first entity
	while (you)                                                                                     // repeat until there are no more entities
	{
		if (you.dt_terrain_skill == dt_skill_value && ent_type(you) == 4)                            // if it is a Terrain with skill99 = 100
		{
			DT_ALL_TERRAIN_ENT[dt_count_terrain] = you;
			dt_count_terrain ++;
		}
		if (you.dt_terrain_skill > dt_skill_value)   set (you,PASSABLE);                             // all entities with skill99 > 100 would not removed, set their passable flag
		you = ent_next(you);                                                                         // get next entity
	}
	
	DT_SWITCH_TERRAIN();                                                                            // search the nearest terrain
	
	dt_fhandle = file_open_read(dt_path_save_ini);
	file_str_readto(dt_fhandle,DT_TEMP_STR,"=",200);   dt_mode            = file_var_read(dt_fhandle);
	file_str_readto(dt_fhandle,DT_TEMP_STR,"=",200);   dt_scan_radius     = file_var_read(dt_fhandle);
	file_str_readto(dt_fhandle,DT_TEMP_STR,"=",200);   dt_vertex_speed    = file_var_read(dt_fhandle);
	file_str_readto(dt_fhandle,DT_TEMP_STR,"=",200);   dt_camera_speed    = file_var_read(dt_fhandle);
	file_str_readto(dt_fhandle,DT_TEMP_STR,"=",200);   dt_lod_vertices    = file_var_read(dt_fhandle);
	file_str_readto(dt_fhandle,DT_TEMP_STR,"=",200);   dt_max_active      = file_var_read(dt_fhandle);
	file_str_readto(dt_fhandle,DT_TEMP_STR,"=",200);   dt_min_active      = file_var_read(dt_fhandle);
	file_str_readto(dt_fhandle,DT_TEMP_STR,"=",200);   dt_max_terrain     = file_var_read(dt_fhandle);
	file_str_readto(dt_fhandle,DT_TEMP_STR,"=",200);   dt_min_terrain     = file_var_read(dt_fhandle);
	file_str_readto(dt_fhandle,DT_TEMP_STR,"=",200);   DT_PANEL_PAN.pos_x = file_var_read(dt_fhandle);
	file_str_readto(dt_fhandle,DT_TEMP_STR,"=",200);   DT_PANEL_PAN.pos_y = file_var_read(dt_fhandle);
	file_close (dt_fhandle);
	DT_MOVE_PANEL(DT_PANEL_PAN);
	
	if (!dt_scan_radius)    dt_scan_radius  = 100;
	if (!dt_vertex_speed)   dt_vertex_speed = 0.5;
	if (!dt_camera_speed)   dt_camera_speed = 1;
	if (!dt_lod_vertices)   dt_lod_vertices = 50;
	
	if (dt_max_active)   button_state(DT_PANEL_PAN,10,1);
	if (dt_min_active)   button_state(DT_PANEL_PAN,11,1);
	
	str_for_num (DT_MIN_STR,dt_min_terrain);
	str_for_num (DT_MAX_STR,dt_max_terrain);
	
	button_state (DT_PANEL_PAN,dt_mode,1);
	set (DT_PANEL_PAN,SHOW);
	
	vec_set(d3d_lodfactor,vector(dt_lod_vertices,100,100));
	mouse_range = camera.clip_far / 100 * dt_lod_vertices;
	mouse_mode = 1;
	mouse_map = dt_cursor;                                                                          // standard Windows Mouse
	
	ent_create("Wuerfel_0.mdl",DT_TEMP,DT_CAMERA);                                                  // create the camera...
}

//*************************************************************************************************//

void DT_BUTTON_TOGGLE(my_button)
{
	switch (my_button)
	{
		case 10:  dt_max_active = !dt_max_active;    break;
		case 11:  dt_min_active = !dt_min_active;    break;
	}
}

void DT_BUTTON_STRING(my_button)
{
	STRING* temp = "     ";
	switch (my_button)
	{
		case 12:
			str_cpy (temp,DT_MAX_STR);
			str_cpy (DT_MAX_STR,"     ");
			result = inkey (DT_MAX_STR);
			if (result == 13 || result == 1)   {if (!str_to_num(DT_MAX_STR))   str_cpy (DT_MAX_STR,temp);}
			else                               {str_cpy (DT_MAX_STR,temp);}
			dt_max_terrain = str_to_num (DT_MAX_STR);
			break;
		case 13:
			str_cpy (temp,DT_MIN_STR);
			str_cpy (DT_MIN_STR,"      ");
			result = inkey (DT_MIN_STR);
			if (result == 13)   {if (!str_to_num(DT_MIN_STR))   str_cpy (DT_MIN_STR,temp);}
			else                {str_cpy (DT_MIN_STR,temp);}
			dt_min_terrain = str_to_num (DT_MIN_STR);
			break;
	}
}

PANEL* DT_PANEL_PAN =
{
	bmap  = "dt_panel.tga";
	pos_x = 20;
	pos_y = 20;
	layer = 100;
	red   = 0;
	green = 0;
	blue  = 0;
	on_click = DT_MOVE_PANEL;
	
	button_radio (17,9  ,"dt_button_on.tga",NULL,"dt_button_over.tga",DT_MODE_NUMBER,NULL,NULL);
	button_radio (83,9  ,"dt_button_on.tga",NULL,"dt_button_over.tga",DT_MODE_NUMBER,NULL,NULL);
	button_radio (17,75 ,"dt_button_on.tga",NULL,"dt_button_over.tga",DT_MODE_NUMBER,NULL,NULL);
	button_radio (83,75 ,"dt_button_on.tga",NULL,"dt_button_over.tga",DT_MODE_NUMBER,NULL,NULL);
	button_radio (17,141,"dt_button_on.tga",NULL,"dt_button_over.tga",DT_MODE_NUMBER,NULL,NULL);
	button_radio (83,141,"dt_button_on.tga",NULL,"dt_button_over.tga",DT_MODE_NUMBER,NULL,NULL);
	button_radio (17,207,"dt_button_on.tga",NULL,"dt_button_over.tga",DT_MODE_NUMBER,NULL,NULL);
	button_radio (83,207,"dt_button_on.tga",NULL,"dt_button_over.tga",DT_MODE_NUMBER,NULL,NULL);
	button_radio (17,273,"dt_button_on.tga",NULL,"dt_button_over.tga",DT_MODE_NUMBER,NULL,NULL);
	
	digits (90,298,5,dt_font_16,1,dt_high_terrain);
	
	hslider (6,332,137,"dt_slider.tga",10,999,dt_scan_radius);
	digits (95,353,4,dt_font_16,1,dt_scan_radius);
	hslider (6,380,137,"dt_slider.tga",0.5,10,dt_vertex_speed);
	hslider (6,428,137,"dt_slider.tga",1,200,dt_camera_speed);
	hslider (6,476,137,"dt_slider.tga",2,15,dt_lod_vertices);
	
	button_toggle(17,531,"dt_button_on_3.tga",NULL,"dt_button_on_over_3.tga","dt_button_over_3.tga",DT_BUTTON_TOGGLE,NULL,NULL);
	button_toggle(17,565,"dt_button_on_3.tga",NULL,"dt_button_on_over_3.tga","dt_button_over_3.tga",DT_BUTTON_TOGGLE,NULL,NULL);
	button (83,532,"dt_button_on_4.tga",NULL,"dt_button_over_4.tga",DT_BUTTON_STRING,NULL,NULL);
	button (83,566,"dt_button_on_4.tga",NULL,"dt_button_over_4.tga",DT_BUTTON_STRING,NULL,NULL);
	
	button (17,599,"dt_button_on_2.tga",NULL,"dt_button_over_2.tga",DT_UNDO,NULL,NULL);
	button (83,599,"dt_button_on_2.tga",NULL,"dt_button_over_2.tga",DT_HELP,NULL,NULL);
	
	button (17,632,"dt_button_on_5.tga",NULL,"dt_button_over_5.tga",DT_SAVE_TERRAIN,NULL,NULL);
	
	button (17,665,"dt_button_on_5.tga",NULL,"dt_button_over_5.tga",DT_SPLICES_TERRAINS,NULL,NULL);
}
